import numpy as np

def F(x):

    """
    Funktion deren Nullstelle gesucht wird

    Input: x ... Punkt an welchem die Funktion F ausgewertet werden soll

    Output: F ... Funktionswert am Punkt x

    """

    # Werte Funktion F aus am Punkt x
    F = np.zeros(2)

    ####################################################################
    #
    # Implementiere HIER die Funktion F
    #
    ####################################################################

    # Rueckgabe
    return F
    
    
def dF(x):

    """
    Jacobi Matrix der Funktion F

    Input: x ... Punkt an welchem die Jacobi Matrix der Funktion F
                 ausgewertet soll

    Output: dF ... Jacobi Matrix von F am Punkt x


    """

    # Werte Jacobie Matrix der Funktion F aus am Punkt x
    dF = np.zeros((2,2))
    ####################################################################
    #
    # Implementiere HIER die Jacobi Matrix dF
    #
    ####################################################################

    # Rueckgabe
    return dF

def dFinv(x):

    """
    Inverse der Jacobi Matrix der Funktion F

    Input: x ... Punkt an welchem die Inverse der Jacobi Matrix der
                 Funktion F ausgewertet werden soll

    Output: dFinv ... Jacobi Matrix von F am Punkt x

    """

    # Werte Inverse der Jacobi Matrix der Funktion F am Punkt x aus
    dFinv = np.zeros((2,2))

    ####################################################################
    #
    # Implementiere HIER die Inverse der Jacobi Matrix der Funktion F
    #
    ####################################################################

    # Rueckgabe
    return dFinv

def Newton(F,dFinv,x0,tol,maxit):

    """
    Newton-Verfahren

    Input: F     ... Funktion deren Nullstelle gesucht wird
           dFinv ... Inverse der Jacobi Matrix von F
           x0    ... Startwert
           tol   ... Genauigkeit
           maxit ... Maximale Anzahl Iterationen

    Output: x         ... Vektor mit allen Iterationswerten (inklusive x0)
            Converged ... Konvergenzflag (Converged = True  falls konvergiert
                                          Converged = False sonst)
            i         ... Anzahl benoetigter Iterationen bis zur Genauigkeit
                          tol

    """

    x = np.zeros((x0.size,maxit)) # initialisiere Iterations-Sequence mit Nulls
    Converged = False
    i = 0

    ####################################################################
    #
    # Implementiere HIER das Newton-Verfahren fuer die Funktion F
    #
    ####################################################################

    # Rueckgabe
    return x,Converged,i

########################################################################
#
#   Bestimmen Sie hier die Nullstelle mit dem Newton-Verfahren
#
########################################################################
